/*
 * Copyright (c) IntellectualCrafters - 2014.
 * You are not allowed to distribute and/or monetize any of our intellectual property.
 * IntellectualCrafters is not affiliated with Mojang AB. Minecraft is a trademark of Mojang AB.
 *
 * >> File = Auto.java
 * >> Generated by: Citymonstret at 2014-08-09 01:40
 */

package com.intellectualcrafters.plot.commands;

import com.intellectualcrafters.plot.*;
import net.milkbowl.vault.economy.Economy;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.entity.Player;

@SuppressWarnings("deprecation")
public class Auto extends SubCommand {

    public Auto() {
        super("auto", "plots.auto", "Claim the nearest plot", "auto", "a", CommandCategory.CLAIMING);
    }

    // TODO auto claim a mega plot!!!!!!!!!!!!
    
    @Override
    public boolean execute(Player plr, String... args) {
        World world;
        if (PlotMain.getPlotWorlds().length == 1) {
            world = Bukkit.getWorld(PlotMain.getPlotWorlds()[0]);
        } else {
            if (PlotMain.isPlotWorld(plr.getWorld())) {
                world = plr.getWorld();
            } else {
                if (args.length == 1) {
                    world = Bukkit.getWorld(args[0]);
                    if (world != null) {
                        if (!PlotMain.isPlotWorld(world)) {
                            PlayerFunctions.sendMessage(plr, C.NOT_VALID_PLOT_WORLD);
                            return true;
                        }

                    } else {
                        PlayerFunctions.sendMessage(plr, C.NOT_VALID_WORLD);
                        return true;
                    }
                } else {
                    PlayerFunctions.sendMessage(plr, C.NOT_IN_PLOT_WORLD);
                    return true;
                }
            }

        }
        if (PlayerFunctions.getPlayerPlotCount(world, plr) >= PlayerFunctions.getAllowedPlots(plr)) {
            PlayerFunctions.sendMessage(plr, C.CANT_CLAIM_MORE_PLOTS);
            return true;
        }
        boolean br = false;
        int x = 0, z = 0, q = 100;
        PlotId id;
        while (!br) {
            id = new PlotId(x, z);
            if (PlotHelper.getPlot(world, id).owner == null) {
                Plot plot = PlotHelper.getPlot(world, id);
                PlotWorld plotworld = PlotMain.getWorldSettings(plot.getWorld());
                if(PlotMain.useEconomy && plotworld.USE_ECONOMY) {
                    double cost = plotworld.PLOT_PRICE;
                    if(cost > 0d) {
                        Economy economy = PlotMain.economy;
                        if(economy.getBalance(plr) < cost) {
                            sendMessage(plr, C.CANNOT_AFFORD_PLOT, "" + cost);
                            return true;
                        }
                        economy.withdrawPlayer(plr, cost);
                        sendMessage(plr, C.REMOVED_BALANCE, cost + "");
                    }
                }
                String schematic;
                if(args.length > 0 && !(schematic = args[0]).equals("")) {
                    if(plotworld.SCHEMATIC_CLAIM_SPECIFY) {
                        if(!plotworld.SCHEMATICS.contains(schematic.toLowerCase())) {
                            sendMessage(plr, C.SCHEMATIC_INVALID, "non-existent");
                            return true;
                        }
                        if(!plr.hasPermission("plots.claim." + schematic) && !plr.hasPermission("plots.admin")) {
                            PlayerFunctions.sendMessage(plr, C.NO_SCHEMATIC_PERMISSION, schematic);
                            return true;
                        }
                    }
                }
                boolean result = Claim.claimPlot(plr, plot, true);
                br = !result;
            }
            if ((z < q) && ((z - x) < q)) {
                z++;
            } else if (x < q) {
                x++;
                z = q - 100;
            } else {
                q += 100;
                x = q;
                z = q;
            }
        }
        return true;
    }

}
